Makefile 15 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438
  1. ifndef VERBOSE
  2. .SILENT:
  3. endif
  4. # Never run this makefile in parallel, as it could screw things up
  5. # It won't affect the submakes, so you still get the speedup from specifying -jx
  6. .NOTPARALLEL:
  7. # Allow the silent with lower caps to work the same way as upper caps
  8. ifdef silent
  9. SILENT = $(silent)
  10. endif
  11. ifdef SILENT
  12. SUB_IS_SILENT := $(SILENT)
  13. endif
  14. # We need to make sure that silent is always turned off at the top level
  15. # Otherwise the [OK], [ERROR] and [WARN] messages won't be displayed correctly
  16. override SILENT := false
  17. ifeq ($(shell git rev-parse --is-inside-work-tree 2>/dev/null),)
  18. export SKIP_GIT := yes
  19. export NOT_REPO := yes
  20. endif
  21. ifdef SKIP_VERSION
  22. export SKIP_GIT := yes
  23. endif
  24. ifndef SUB_IS_SILENT
  25. ifndef SKIP_GIT
  26. QMK_VERSION := $(shell git describe --abbrev=0 --tags 2>/dev/null)
  27. endif
  28. ifneq ($(QMK_VERSION),)
  29. $(info QMK Firmware $(QMK_VERSION))
  30. endif
  31. endif
  32. # Determine which qmk cli to use
  33. QMK_BIN := qmk
  34. # avoid 'Entering|Leaving directory' messages
  35. MAKEFLAGS += --no-print-directory
  36. ON_ERROR := error_occurred=1
  37. BREAK_ON_ERRORS = no
  38. ROOT_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
  39. ifeq ($(ROOT_DIR),)
  40. ROOT_DIR := .
  41. endif
  42. include paths.mk
  43. TEST_OUTPUT_DIR := $(BUILD_DIR)/test
  44. ERROR_FILE := $(BUILD_DIR)/error_occurred
  45. .DEFAULT_GOAL := all:all
  46. # Compare the start of the RULE variable with the first argument($1)
  47. # If the rules equals $1 or starts with $1:, RULE_FOUND is set to true
  48. # and $1 is removed from the RULE variable
  49. # Otherwise the RULE_FOUND variable is set to false, and RULE left as it was
  50. # The function is a bit tricky, since there's no built in $(startswith) function
  51. define COMPARE_AND_REMOVE_FROM_RULE_HELPER
  52. ifeq ($1,$$(RULE))
  53. RULE:=
  54. RULE_FOUND := true
  55. else
  56. STARTCOLON_REMOVED=$$(subst START$1:,,START$$(RULE))
  57. ifneq ($$(STARTCOLON_REMOVED),START$$(RULE))
  58. RULE_FOUND := true
  59. RULE := $$(STARTCOLON_REMOVED)
  60. else
  61. RULE_FOUND := false
  62. endif
  63. endif
  64. endef
  65. # This makes it easier to call COMPARE_AND_REMOVE_FROM_RULE, since it makes it behave like
  66. # a function that returns the value
  67. COMPARE_AND_REMOVE_FROM_RULE = $(eval $(call COMPARE_AND_REMOVE_FROM_RULE_HELPER,$1))$(RULE_FOUND)
  68. # Try to find a match for the start of the rule to be checked
  69. # $1 The list to be checked
  70. # If a match is found, then RULE_FOUND is set to true
  71. # and MATCHED_ITEM to the item that was matched
  72. define TRY_TO_MATCH_RULE_FROM_LIST_HELPER
  73. # Split on ":", padding with empty strings to avoid indexing issues
  74. TOKEN1:=$$(shell python3 -c "import sys; print((sys.argv[1].split(':',1)+[''])[0])" $$(RULE))
  75. TOKENr:=$$(shell python3 -c "import sys; print((sys.argv[1].split(':',1)+[''])[1])" $$(RULE))
  76. FOUNDx:=$$(shell echo $1 | tr " " "\n" | grep -Fx $$(TOKEN1))
  77. ifneq ($$(FOUNDx),)
  78. RULE := $$(TOKENr)
  79. RULE_FOUND := true
  80. MATCHED_ITEM := $$(TOKEN1)
  81. else
  82. RULE_FOUND := false
  83. MATCHED_ITEM :=
  84. endif
  85. endef
  86. # Make it easier to call TRY_TO_MATCH_RULE_FROM_LIST
  87. TRY_TO_MATCH_RULE_FROM_LIST = $(eval $(call TRY_TO_MATCH_RULE_FROM_LIST_HELPER,$1))$(RULE_FOUND)
  88. define ALL_IN_LIST_LOOP
  89. OLD_RULE$1 := $$(RULE)
  90. $$(eval $$(call $1,$$(ITEM$1)))
  91. RULE := $$(OLD_RULE$1)
  92. endef
  93. define PARSE_ALL_IN_LIST
  94. $$(foreach ITEM$1,$2,$$(eval $$(call ALL_IN_LIST_LOOP,$1)))
  95. endef
  96. # The entry point for rule parsing
  97. # parses a rule in the format <keyboard>:<keymap>:<target>
  98. # but this particular function only deals with the first <keyboard> part
  99. define PARSE_RULE
  100. RULE := $1
  101. COMMANDS :=
  102. # If the rule starts with all, then continue the parsing from
  103. # PARSE_ALL_KEYBOARDS
  104. ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
  105. KEYBOARD_RULE=all
  106. $$(eval $$(call PARSE_ALL_KEYBOARDS))
  107. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,test),true)
  108. $$(eval $$(call PARSE_TEST))
  109. # If the rule starts with the name of a known keyboard, then continue
  110. # the parsing from PARSE_KEYBOARD
  111. else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(shell $(QMK_BIN) list-keyboards --no-resolve-defaults)),true)
  112. KEYBOARD_RULE=$$(MATCHED_ITEM)
  113. $$(eval $$(call PARSE_KEYBOARD,$$(MATCHED_ITEM)))
  114. else
  115. $$(info make: *** No rule to make target '$1'. Stop.)
  116. $$(info |)
  117. $$(info | QMK's make format is:)
  118. $$(info | make keyboard_folder:keymap_folder[:target])
  119. $$(info |)
  120. $$(info | Where `keyboard_folder` is the path to the keyboard relative to)
  121. $$(info | `qmk_firmware/keyboards/`, and `keymap_folder` is the name of the)
  122. $$(info | keymap folder under that board's `keymaps/` directory.)
  123. $$(info |)
  124. $$(info | Examples:)
  125. $$(info | keyboards/dz60, keyboards/dz60/keymaps/default)
  126. $$(info | -> make dz60:default)
  127. $$(info | -> qmk compile -kb dz60 -km default)
  128. $$(info | keyboards/planck/rev6, keyboards/planck/keymaps/default)
  129. $$(info | -> make planck/rev6:default:flash)
  130. $$(info | -> qmk flash -kb planck/rev6 -km default)
  131. $$(info |)
  132. endif
  133. endef
  134. # $1 = Keyboard
  135. # Parses a rule in the format <keymap>:<target>
  136. # the keyboard is already known when entering this function
  137. define PARSE_KEYBOARD
  138. # If we want to compile the default subproject, then we need to
  139. # include the correct makefile to determine the actual name of it
  140. CURRENT_KB := $1
  141. # KEYBOARD_FOLDERS := $$(subst /, , $(CURRENT_KB))
  142. DEFAULT_FOLDER := $$(CURRENT_KB)
  143. # We assume that every rules.mk will contain the full default value
  144. $$(eval include $(ROOT_DIR)/keyboards/$$(CURRENT_KB)/rules.mk)
  145. ifneq ($$(DEFAULT_FOLDER),$$(CURRENT_KB))
  146. $$(eval include $(ROOT_DIR)/keyboards/$$(DEFAULT_FOLDER)/rules.mk)
  147. endif
  148. CURRENT_KB := $$(DEFAULT_FOLDER)
  149. # 5/4/3/2/1
  150. KEYBOARD_FOLDER_PATH_1 := $$(CURRENT_KB)
  151. KEYBOARD_FOLDER_PATH_2 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_1)))
  152. KEYBOARD_FOLDER_PATH_3 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_2)))
  153. KEYBOARD_FOLDER_PATH_4 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_3)))
  154. KEYBOARD_FOLDER_PATH_5 := $$(patsubst %/,%,$$(dir $$(KEYBOARD_FOLDER_PATH_4)))
  155. KEYMAPS :=
  156. # get a list of all keymaps
  157. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_1)/keymaps/*/.)))
  158. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_2)/keymaps/*/.)))
  159. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_3)/keymaps/*/.)))
  160. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_4)/keymaps/*/.)))
  161. KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/keyboards/$$(KEYBOARD_FOLDER_PATH_5)/keymaps/*/.)))
  162. KEYBOARD_LAYOUTS := $(shell $(QMK_BIN) list-layouts --keyboard $1)
  163. LAYOUT_KEYMAPS :=
  164. $$(foreach LAYOUT,$$(KEYBOARD_LAYOUTS),$$(eval LAYOUT_KEYMAPS += $$(notdir $$(patsubst %/.,%,$$(wildcard $(ROOT_DIR)/layouts/*/$$(LAYOUT)/*/.)))))
  165. KEYMAPS := $$(sort $$(KEYMAPS) $$(LAYOUT_KEYMAPS))
  166. # if the rule after removing the start of it is empty (we haven't specified a kemap or target)
  167. # compile all the keymaps
  168. ifeq ($$(RULE),)
  169. $$(eval $$(call PARSE_ALL_KEYMAPS))
  170. # The same if all was specified
  171. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,all),true)
  172. $$(eval $$(call PARSE_ALL_KEYMAPS))
  173. # List all keymaps for the given keyboard
  174. else ifeq ($$(call COMPARE_AND_REMOVE_FROM_RULE,list-keymaps),true)
  175. $$(eval $$(call LIST_ALL_KEYMAPS))
  176. # Try to match the specified keyamp with the list of known keymaps
  177. else ifeq ($$(call TRY_TO_MATCH_RULE_FROM_LIST,$$(KEYMAPS)),true)
  178. $$(eval $$(call PARSE_KEYMAP,$$(MATCHED_ITEM)))
  179. # Otherwise try to match the keymap from the current folder, or arguments to the make command
  180. else ifneq ($$(KEYMAP),)
  181. $$(eval $$(call PARSE_KEYMAP,$$(KEYMAP)))
  182. # Otherwise if we are running make all:<user> just skip
  183. else ifeq ($$(KEYBOARD_RULE),all)
  184. # $$(info Skipping: No user keymap for $$(CURRENT_KB))
  185. # Otherwise, make all keymaps, again this is consistent with how it works without
  186. # any arguments
  187. else
  188. $$(eval $$(call PARSE_ALL_KEYMAPS))
  189. endif
  190. endef
  191. # if we are going to compile all keyboards, match the rest of the rule
  192. # for each of them
  193. define PARSE_ALL_KEYBOARDS
  194. $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYBOARD,$(shell $(QMK_BIN) list-keyboards --no-resolve-defaults)))
  195. endef
  196. # Prints a list of all known keymaps for the given keyboard
  197. define LIST_ALL_KEYMAPS
  198. COMMAND_true_LIST_KEYMAPS := \
  199. printf "$$(KEYMAPS)\n";
  200. COMMAND_false_LIST_KEYMAPS := \
  201. printf "$$(MSG_AVAILABLE_KEYMAPS)\n"; \
  202. printf "$$(KEYMAPS)\n";
  203. COMMANDS += LIST_KEYMAPS
  204. endef
  205. # $1 Keymap
  206. # This is the meat of compiling a keyboard, when entering this, everything is known
  207. # keyboard, subproject, and keymap
  208. # Note that we are not directly calling the command here, but instead building a list,
  209. # which will later be processed
  210. define PARSE_KEYMAP
  211. CURRENT_KM = $1
  212. # The rest of the rule is the target
  213. # Remove the leading ":" from the target, as it acts as a separator
  214. MAKE_TARGET := $$(patsubst :%,%,$$(RULE))
  215. # We need to generate an unique identifier to append to the COMMANDS list
  216. CURRENT_KB_UNDER := $$(subst /,_,$$(CURRENT_KB))
  217. COMMAND := COMMAND_KEYBOARD_$$(CURRENT_KB_UNDER)_KEYMAP_$$(CURRENT_KM)
  218. # If we are compiling a keyboard without a subproject, we want to display just the name
  219. # of the keyboard, otherwise keyboard/subproject
  220. KB_SP := $$(CURRENT_KB)
  221. # Format it in bold
  222. KB_SP := $(BOLD)$$(KB_SP)$(NO_COLOR)
  223. # Specify the variables that we are passing forward to submake
  224. MAKE_VARS := KEYBOARD=$$(CURRENT_KB) KEYMAP=$$(CURRENT_KM) QMK_BIN=$$(QMK_BIN)
  225. # And the first part of the make command
  226. MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f $(BUILDDEFS_PATH)/build_keyboard.mk $$(MAKE_TARGET)
  227. # The message to display
  228. MAKE_MSG := $$(MSG_MAKE_KB)
  229. # We run the command differently, depending on if we want more output or not
  230. # The true version for silent output and the false version otherwise
  231. $$(eval $$(call BUILD))
  232. endef
  233. define BUILD
  234. MAKE_VARS += VERBOSE=$(VERBOSE) COLOR=$(COLOR)
  235. COMMANDS += $$(COMMAND)
  236. COMMAND_true_$$(COMMAND) := \
  237. printf "$$(MAKE_MSG)" | \
  238. $$(MAKE_MSG_FORMAT); \
  239. LOG=$$$$($$(MAKE_CMD) $$(MAKE_VARS) SILENT=true 2>&1) ; \
  240. if [ $$$$? -gt 0 ]; \
  241. then $$(PRINT_ERROR_PLAIN); \
  242. elif [ "$$$$LOG" = "skipped" ] ; \
  243. then $$(PRINT_SKIPPED_PLAIN); \
  244. elif [ "$$$$LOG" != "" ] ; \
  245. then $$(PRINT_WARNING_PLAIN); \
  246. else \
  247. $$(PRINT_OK); \
  248. fi;
  249. COMMAND_false_$$(COMMAND) := \
  250. printf "$$(MAKE_MSG)\n\n"; \
  251. $$(MAKE_CMD) $$(MAKE_VARS) SILENT=false; \
  252. if [ $$$$? -gt 0 ]; \
  253. then error_occurred=1; \
  254. fi;
  255. endef
  256. # Just parse all the keymaps for a specific keyboard
  257. define PARSE_ALL_KEYMAPS
  258. $$(eval $$(call PARSE_ALL_IN_LIST,PARSE_KEYMAP,$$(KEYMAPS)))
  259. endef
  260. define BUILD_TEST
  261. TEST_PATH := $1
  262. TEST_NAME := $$(notdir $$(TEST_PATH))
  263. TEST_FULL_NAME := $$(subst /,_,$$(patsubst $$(ROOT_DIR)tests/%,%,$$(TEST_PATH)))
  264. MAKE_TARGET := $2
  265. COMMAND := $1
  266. MAKE_CMD := $$(MAKE) -r -R -C $(ROOT_DIR) -f $(BUILDDEFS_PATH)/build_test.mk $$(MAKE_TARGET)
  267. MAKE_VARS := TEST=$$(TEST_NAME) TEST_OUTPUT=$$(TEST_FULL_NAME) TEST_PATH=$$(TEST_PATH) FULL_TESTS="$$(FULL_TESTS)"
  268. MAKE_MSG := $$(MSG_MAKE_TEST)
  269. $$(eval $$(call BUILD))
  270. ifneq ($$(MAKE_TARGET),clean)
  271. TEST_EXECUTABLE := $$(TEST_OUTPUT_DIR)/$$(TEST_FULL_NAME).elf
  272. TESTS += $$(TEST_FULL_NAME)
  273. TEST_MSG := $$(MSG_TEST)
  274. $$(TEST_FULL_NAME)_COMMAND := \
  275. printf "$$(TEST_MSG)\n"; \
  276. $$(TEST_EXECUTABLE); \
  277. if [ $$$$? -gt 0 ]; \
  278. then error_occurred=1; \
  279. fi; \
  280. printf "\n";
  281. endif
  282. endef
  283. define PARSE_TEST
  284. TESTS :=
  285. # list of possible targets, colon-delimited, to reassign to MAKE_TARGET and remove
  286. TARGETS := :clean:
  287. ifneq (,$$(findstring :$$(lastword $$(subst :, ,$$(RULE))):, $$(TARGETS)))
  288. MAKE_TARGET := $$(lastword $$(subst :, ,$$(RULE)))
  289. TEST_SUBPATH := $$(subst $$(eval) ,/,$$(wordlist 2, $$(words $$(subst :, ,$$(RULE))), _ $$(subst :, ,$$(RULE))))
  290. else
  291. MAKE_TARGET :=
  292. TEST_SUBPATH := $$(subst :,/,$$(RULE))
  293. endif
  294. include $(BUILDDEFS_PATH)/testlist.mk
  295. ifeq ($$(RULE),all)
  296. MATCHED_TESTS := $$(TEST_LIST)
  297. else
  298. MATCHED_TESTS := $$(foreach TEST, $$(TEST_LIST),$$(if $$(findstring /$$(TEST_SUBPATH)/, $$(patsubst %,%/,$$(TEST))), $$(TEST),))
  299. endif
  300. $$(foreach TEST,$$(MATCHED_TESTS),$$(eval $$(call BUILD_TEST,$$(TEST),$$(MAKE_TARGET))))
  301. endef
  302. # Set the silent mode depending on if we are trying to compile multiple keyboards or not
  303. # By default it's on in that case, but it can be overridden by specifying silent=false
  304. # from the command line
  305. define SET_SILENT_MODE
  306. ifdef SUB_IS_SILENT
  307. SILENT_MODE := $(SUB_IS_SILENT)
  308. else ifeq ($$(words $$(COMMANDS)),1)
  309. SILENT_MODE := false
  310. else
  311. SILENT_MODE := true
  312. endif
  313. endef
  314. include $(BUILDDEFS_PATH)/message.mk
  315. ifeq ($(strip $(BREAK_ON_ERRORS)), yes)
  316. HANDLE_ERROR = exit 1
  317. else
  318. HANDLE_ERROR = echo $$error_occurred > $(ERROR_FILE)
  319. endif
  320. # The empty line is important here, as it will force a new shell to be created for each command
  321. # Otherwise the command line will become too long with a lot of keyboards and keymaps
  322. define RUN_COMMAND
  323. +error_occurred=0;\
  324. $(COMMAND_$(SILENT_MODE)_$(COMMAND))\
  325. if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
  326. endef
  327. define RUN_TEST
  328. +error_occurred=0;\
  329. $($(TEST)_COMMAND)\
  330. if [ $$error_occurred -gt 0 ]; then $(HANDLE_ERROR); fi;
  331. endef
  332. # Catch everything and parse the command line ourselves.
  333. .PHONY: %
  334. %:
  335. # Ensure that $(QMK_BIN) works.
  336. if ! $(QMK_BIN) hello 1> /dev/null 2>&1; then printf "$(MSG_PYTHON_MISSING)"; exit 1; fi
  337. ifdef NOT_REPO
  338. printf "$(MSG_NOT_REPO)"
  339. endif
  340. ifndef SKIP_GIT
  341. $(QMK_BIN) git-submodule --sync
  342. # Check if the submodules are dirty, and display a warning if they are
  343. if ! $(QMK_BIN) git-submodule --check 1> /dev/null 2>&1; then printf "$(MSG_SUBMODULE_DIRTY)"; fi
  344. endif
  345. rm -f $(ERROR_FILE) > /dev/null 2>&1
  346. $(eval $(call PARSE_RULE,$@))
  347. $(eval $(call SET_SILENT_MODE))
  348. # Run all the commands in the same shell, notice the + at the first line
  349. # it has to be there to allow parallel execution of the submake
  350. # This always tries to compile everything, even if error occurs in the middle
  351. # But we return the error code at the end, to trigger travis failures
  352. # The sort at this point is to remove duplicates
  353. $(foreach COMMAND,$(sort $(COMMANDS)),$(RUN_COMMAND))
  354. if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
  355. $(foreach TEST,$(sort $(TESTS)),$(RUN_TEST))
  356. if [ -f $(ERROR_FILE) ]; then printf "$(MSG_ERRORS)" & exit 1; fi;
  357. lib/%:
  358. git submodule sync $?
  359. git submodule update --init $?
  360. .PHONY: git-submodule
  361. git-submodule:
  362. $(QMK_BIN) git-submodule
  363. .PHONY: git-submodules
  364. git-submodules: git-submodule
  365. .PHONY: list-keyboards
  366. list-keyboards:
  367. $(QMK_BIN) list-keyboards --no-resolve-defaults | tr '\n' ' '
  368. .PHONY: generate-keyboards-file
  369. generate-keyboards-file:
  370. $(QMK_BIN) list-keyboards --no-resolve-defaults
  371. .PHONY: clean
  372. clean:
  373. echo -n 'Deleting .build/ ... '
  374. rm -rf $(BUILD_DIR)
  375. echo 'done.'
  376. .PHONY: distclean
  377. distclean: clean
  378. echo -n 'Deleting *.bin, *.hex, and *.uf2 ... '
  379. rm -f *.bin *.hex *.uf2
  380. echo 'done.'